/*

 * @(#)Courbe.java	6/12/2000

 *

 */



import java.awt.*;

import java.awt.event.*;

import java.applet.*;

import java.io.*;

import java.util.*;





/**

 * Trac d'quations diffrentielles

 * peut tre lance soit comme une Applet, 

 * soit comme une application indpendante

 */



public class Equadiff extends Applet implements ActionListener,ItemListener,MouseListener,TextListener{

   TextField tMinText,tMaxText,tNbText,xText,yText,zoomText;

   Label xLabel,yLabel;

   Button effaceButton,traceButton;

   EqdiffCanvas c;

   Checkbox grilleCheckbox;

   Choice typeChoice,colorChoice;

   double zoom=1;

   

   

   

    public void init() {

	setLayout(new KappaLayout());

	

	add(new Label("min de t="),"0,0,,,,,");

	tMinText=new TextField((new Double(-3)).toString(),6);

	add(tMinText,"1,0,,,,,");

	tMinText.setEnabled(false);

	add(new Label("max de t="),"2,0,,,,,");

	tMaxText=new TextField((new Double(3)).toString(),6);

	add(tMaxText,"3,0,,,,,");

	tMaxText.setEnabled(false);

	add(new Label("nb de points="),"4,0,,,,,");

	tNbText=new TextField((new Integer(1000)).toString(),4);

	add(tNbText,"5,0,,,,,");

	tNbText.addTextListener(this);

	// champs x,y

	add(xLabel =new Label("x' = "),"0,1,,,,,");

	xText=new TextField("1",20);

	add(xText,"1,1,2,,,,");

	xText.addTextListener(this);

	xText.setEnabled(false);

	add(yLabel =new Label("y' = "),"3,1,,,,,");

	yText=new TextField("x+y^2",20);

	add(yText,"4,1,2,,,,");

	yText.addTextListener(this);

	

	// boutons de trac

	add(new Label("zoom="),"0,2,,,,,");

	zoomText=new TextField((new Double(1)).toString(),4);

	add(zoomText,"1,2,,,,,");

	zoomText.addTextListener(this);

	typeChoice=new Choice();

	typeChoice.add("y'=f(x,y)");

	typeChoice.add("x'=f(t,x,y),y'=g(t,x,y)");

	typeChoice.add("courbe x=f(t),y=g(t)");

    add(typeChoice,"2,2,2,,,,");

	typeChoice.addItemListener(this);

	typeChoice.select(0);

	colorChoice=new Choice();

	colorChoice.add("rouge");

	colorChoice.add("bleu");

	colorChoice.add("vert");

	colorChoice.add("cyan");

	colorChoice.add("jaune");

	colorChoice.add("magenta");

	colorChoice.add("orange");

	colorChoice.add("noir");

    add(colorChoice,"4,2,,,,,");

	colorChoice.addItemListener(this);

	colorChoice.select(0);

	grilleCheckbox = new Checkbox("grille");

    add(grilleCheckbox,"5,2,,,,,");

	grilleCheckbox.addItemListener(this);

	effaceButton=new Button("effacer");

	add(effaceButton,"1,3,2,,,hw,");

	effaceButton.addActionListener(this);

	traceButton=new Button("retracer");

	add(traceButton,"3,3,2,,,hw,");

	traceButton.addActionListener(this);

	// pour les tracs

	add(KappaLayout.createVerticalStrut(400),"0 , 4 , , , , , ");

	c = new EqdiffCanvas(-3,3,1000,"1","x+y^2",1);

	add(c,"1,4,5,,,hw,");

	c.addMouseListener(this);

	}

    



    public void actionPerformed(ActionEvent e) {

		if(e.getSource()==effaceButton) {

			c.efface();

		}

		if(e.getSource()==traceButton) {

			c.retrace();

		}

    }

    

	public void itemStateChanged(ItemEvent e) {

              if(e.getItemSelectable() == grilleCheckbox){

                                c.changeGrille();

              }

              if(e.getItemSelectable()== typeChoice) {

              	String s=((Choice) e.getItemSelectable()).getSelectedItem();

              	if(s.equals("y'=f(x,y)")) {

              		c.setType(EqdiffCanvas.EQDIFF);

					xText.setEnabled(false);

					tMinText.setEnabled(false);

					tMaxText.setEnabled(false);

					xLabel.setText("");

					yLabel.setText("y'=");

					

					

              	}

				if(s.equals("x'=f(t,x,y),y'=g(t,x,y)")) {

              		c.setType(EqdiffCanvas.SYSDIFF);

					xText.setEnabled(true);

					tMinText.setEnabled(true);

					tMaxText.setEnabled(true);

					xLabel.setText("x'=");

					yLabel.setText("y'=");

              	}

				if(s.equals("courbe x=f(t),y=g(t)")) {

					c.setType(EqdiffCanvas.COURBE);

					xText.setEnabled(true);

					tMinText.setEnabled(true);

					tMaxText.setEnabled(true);

					xLabel.setText("x =");

					yLabel.setText("y =");

				}

				

              }

			  if(e.getItemSelectable()== colorChoice) {

              	String s=((Choice) e.getItemSelectable()).getSelectedItem();

              	if(s.equals("rouge")) {

              		c.setColor(Color.red);

              	}

				if(s.equals("bleu")) {

              		c.setColor(Color.blue);

              	}

				if(s.equals("vert")) {

              		c.setColor(Color.green);

              	}

				if(s.equals("cyan")) {

              		c.setColor(Color.cyan);

              	}

				if(s.equals("jaune")) {

              		c.setColor(Color.yellow);

              	}

				if(s.equals("magenta")) {

              		c.setColor(Color.magenta);

              	}

				if(s.equals("orange")) {

              		c.setColor(Color.orange);

              	}

				if(s.equals("noir")) {

              		c.setColor(Color.black);

              	}

              }

                        

	}

	

	public void mousePressed(MouseEvent e){

                }



   	public void mouseClicked(MouseEvent e){

               c.traceCourbe(e.getX(),e.getY());

                }



   	public void mouseReleased(MouseEvent e){

                        }





   	public void mouseEntered(MouseEvent e){

                        }



   	public void mouseExited(MouseEvent e){

                        }

	

	public void textValueChanged(TextEvent e) {

		int tNb;

		double tMin,tMax;

		try {

				tNb=Integer.parseInt(tNbText.getText());

				tMin=(Double.valueOf(tMinText.getText())).doubleValue();

				tMax=(Double.valueOf(tMaxText.getText())).doubleValue();

				zoom=(Double.valueOf(zoomText.getText())).doubleValue();

			}

			catch(NumberFormatException erreur) {

				tMin=-3;

				tMax=3;

				tNb=200;

				zoom=1;

			}

		c.entreParams(tMin,tMax,tNb,xText.getText(),yText.getText(),zoom);

	}

	

    

    public static void main(String args[]) {

	Frame f = new Frame("Equation differentielle");

	Equadiff	equadiff = new Equadiff();



	equadiff.init();

	equadiff.start();



	f.add("Center", equadiff);

	f.setSize(400, 400);

	f.show();

    }

}





class EqdiffCanvas extends Canvas {

	public static final int EQDIFF=0, SYSDIFF=1, COURBE=2;

    int		maxHor = 300;

    int		maxVer = 300;

	int nombrePoints;

	double xMin = -3;

	double xMax= 3;

	double yMin= -3;

	double yMax=3;

	double tDebut,tFin;

	boolean grille=false;

	String fctX,fctY;

	Analyseur anal=new Analyseur();

	int type=EQDIFF;

	Vector courbesListe=new Vector();

	Color couleur=Color.red;

	

	

	EqdiffCanvas(double tMin, double tMax,int Nb, String x,String y,double zoom) {

		super();

		tDebut=tMin;

		tFin=tMax;

		nombrePoints=Nb;

		xMin=-3/zoom;

		xMax=-xMin;

		yMin=-3/zoom;

		yMax=-yMin;

		fctX=x;

		fctY=y;

	}

	

	void changeGrille() {

		grille=!grille;

		repaint();

	}

	

	void setType(int type) {

		this.type=type;

	}

	

	void efface() {

		courbesListe=new Vector();

		repaint();

	}

	

	void retrace() {

		repaint();

	}

	

	

	void setColor(Color couleur) {

		this.couleur=couleur;

	}

	

	

	

	void entreParams(double tMin, double tMax,int Nb, String x,String y,double zoom) {

		tDebut=tMin;

		tFin=tMax;

		nombrePoints=Nb;

		xMin=-3/zoom;

		xMax=-xMin;

		yMin=-3/zoom;

		yMax=-yMin;

		fctX=x;

		fctY=y;

	}

	

	int xEcran(double x,double xDebut,double xFin) {

		return (int) ((x-xDebut)/(xFin-xDebut)*maxHor);

	}

	

	int yEcran(double y,double yDebut,double yFin) {

		return (int) ((yFin-y)/(yFin-yDebut)*maxVer);

	}

	

	int[] xEcranArray(double[] xArray,double xDebut,double xFin) {

		int[] xe = new int[xArray.length];

		double x;

		

		for(int i=0;i<xArray.length;i++) {

			x=xArray[i];

			if(x>xFin) x = xFin+10;

			else if(x<xDebut) x=xDebut-10;

			xe[i]=(int) ((x-xDebut)/(xFin-xDebut)*maxHor);

		}

		return xe;

	}

	

	int[] yEcranArray(double[] yArray,double yDebut,double yFin) {

		int[] ye = new int[yArray.length];

		double y;

		

		for(int i=0;i<yArray.length;i++) {

			y=yArray[i];

			if(y>yFin) y=yFin+10;

			else if(y<yDebut) y=yDebut-10; 

			ye[i]=(int) ((yFin-y)/(yFin-yDebut)*maxVer);

		}

		return ye;

	}

	

	double xFloat(int x,double xDebut,double xFin) {

		return xDebut+ x *(xFin-xDebut)/maxHor;

	}

	

	double yFloat(int y,double yDebut,double yFin) {

		return yFin - y *(yFin-yDebut)/maxVer;

	}

	

	void traceCourbe(int xInt,int yInt) {

		Rectangle r = getBounds();

	    double x0,y0,h;

		maxVer = r.height;

		maxHor = r.width;

		x0=xFloat(xInt,xMin,xMax);

		y0=yFloat(yInt,yMin,yMax);

		switch(type) {

			case EQDIFF:

				h=(xMax-xMin)/nombrePoints;

				calcule(x0,y0,h,(int) Math.ceil((xMax-x0)/h));

				calcule(x0,y0,-h,(int) Math.ceil((x0-xMin)/h));

				break;

			case SYSDIFF:

			    h=(tFin-tDebut)/nombrePoints;

				calculeSys((tFin+tDebut)/2,x0,y0,h,nombrePoints/2);

				calculeSys((tFin+tDebut)/2,x0,y0,-h,nombrePoints/2);

				break;

			case COURBE:

			    h=(tFin-tDebut)/nombrePoints;

				calculeCourbe(tDebut,tFin,h,nombrePoints);

				break;

				

		}

		repaint();

	}

	

	

	public void calcule(double x0,double y0,double h,int nb) {

		Expression xExpr=Expression.nouvelleExpression(0),yExpr=Expression.nouvelleExpression(0);

		double h2=h/2,k1,k2,k3,k4;

		double x=x0,y=y0;

		double[] xArray = new double[nb];

		double[] yArray = new double[nb];

		try {

				xExpr=anal.analyse(fctX); // System.out.println(xExpr);

				yExpr=anal.analyse(fctY); // System.out.println(yExpr);

		} catch (IOException e) {

				System.err.print("Syntaxe incorrecte");

				System.exit(1);

		}

		for(int i=0;i<nb;i++) {

			xArray[i]=x; 

			yArray[i]=y;

			k1=h*yExpr.evalue("x",x,"y",y);

			k2=h*yExpr.evalue("x",x+h2,"y",y+k1/2);

			k3=h*yExpr.evalue("x",x+h2,"y",y+k2/2);

			k4=h*yExpr.evalue("x",x+h,"y",y+k3);

			x+=h;

			y+=(k1+2*k2+2*k3+k4)/6;

		}

		courbesListe.addElement(couleur);

		courbesListe.addElement(xArray);

		courbesListe.addElement(yArray);

	}

	

	public void calculeSys(double t0,double x0,double y0,double h,int nb) {

		Expression xExpr=Expression.nouvelleExpression(0),yExpr=Expression.nouvelleExpression(0);

		double h2=h/2,kx1,kx2,kx3,kx4,ky1,ky2,ky3,ky4;

		double x=x0,y=y0,t=t0;

		double[] xArray = new double[nb];

		double[] yArray = new double[nb];

		try {

				xExpr=anal.analyse(fctX); // System.out.println(xExpr);

				yExpr=anal.analyse(fctY); // System.out.println(yExpr);

		} catch (IOException e) {

				System.err.print("Syntaxe incorrecte");

				System.exit(1);

		}

		for(int i=0;i<nb;i++) {

			xArray[i]=x; 

			yArray[i]=y;

			kx1=h*xExpr.evalue("t",t,"x",x,"y",y);

			ky1=h*yExpr.evalue("t",t,"x",x,"y",y);

			kx2=h*xExpr.evalue("t",t+h2,"x",x+kx1/2,"y",y+ky1/2);

			ky2=h*yExpr.evalue("t",t+h2,"x",x+kx1/2,"y",y+ky1/2);

			kx3=h*xExpr.evalue("t",t+h2,"x",x+kx2/2,"y",y+ky2/2);

			ky3=h*yExpr.evalue("t",t+h2,"x",x+kx2/2,"y",y+ky2/2);

			kx4=h*xExpr.evalue("t",t+h,"x",x+kx3,"y",y+ky3);

			ky4=h*yExpr.evalue("t",t+h,"x",x+kx3,"y",y+ky3);

			t+=h;

			x+=(kx1+2*kx2+2*kx3+kx4)/6;

			y+=(ky1+2*ky2+2*ky3+ky4)/6;

		}

		courbesListe.addElement(couleur);

		courbesListe.addElement(xArray);

		courbesListe.addElement(yArray);

	}

	

	public void calculeCourbe(double tMin,double tMax, double h, int nb) {

		Expression xExpr=Expression.nouvelleExpression(0),yExpr=Expression.nouvelleExpression(0);

		double[] xArray = new double[nb];

		double[] yArray = new double[nb];

		try {

				xExpr=anal.analyse(fctX); // System.out.println(xExpr);

				yExpr=anal.analyse(fctY); // System.out.println(yExpr);

		} catch (IOException e) {

				System.err.print("Syntaxe incorrecte");

				System.exit(1);

		}

		double t=tMin;

		for(int i=0; i<nb; i++,t+=h) {

			xArray[i]=xExpr.evalue("t",t);

			yArray[i]=yExpr.evalue("t",t);

		}

		courbesListe.addElement(couleur);

		courbesListe.addElement(xArray);

		courbesListe.addElement(yArray);

	}

	

		

    

    public void paint(Graphics g){

		double[] xArray,yArray;

		Rectangle r = getBounds();

		Enumeration enumCourbes;

		int x1,y1,x2,y2;

		

		maxVer = r.height;

		maxHor = r.width;

		// On trace les axes

		g.setColor(Color.blue);

		x1=xEcran(xMin,xMin,xMax);

		x2=xEcran(xMax,xMin,xMax);

		y1=yEcran(0,yMin,yMax);

		g.drawLine(x1,y1,x2,y1);

		x1=xEcran(0,xMin,xMax);

		y1=yEcran(yMin,yMin,yMax);

		y2=yEcran(yMax,yMin,yMax);

		g.drawLine(x1,y1,x1,y2);

		

		// on trace la grille

		if(grille) {

			g.setColor(Color.green);

			for(int i=(int)Math.ceil(xMin);i<=(int)Math.floor(xMax);i++) {

				if(i!=0) {

					x1=xEcran(i,xMin,xMax);

					y1=yEcran(yMin,yMin,yMax);

					y2=yEcran(yMax,yMin,yMax);

					g.drawLine(x1,y1,x1,y2);

				}

			}

			for(int i=(int)Math.ceil(yMin);i<=(int)Math.floor(yMax);i++) {

				if(i!=0) {

					x1=xEcran(xMin,xMin,xMax);

					x2=xEcran(xMax,xMin,xMax);

					y1=yEcran(i,yMin,yMax);

					g.drawLine(x1,y1,x2,y1);

				}

			}

		}

		// g.setColor(Color.red);

		enumCourbes=courbesListe.elements();

		while(enumCourbes.hasMoreElements()) {

			g.setColor((Color) enumCourbes.nextElement());

			xArray=(double[]) enumCourbes.nextElement();

			yArray=(double[]) enumCourbes.nextElement();

			g.drawPolyline(xEcranArray(xArray,xMin,xMax),yEcranArray(yArray,yMin,yMax),xArray.length);

		}

    }



}



