public class matrice {
    private float [][] a;
    private int col,row;
    matrice(float t,int n) {
         a=new float[n][n];
	 col=n;
	 row=n;
         for(int i=0;i<n;i++) 
             for(int j=0;j<n;j++) 
                     a[i][j]= i==j? t : 0;
     }
     matrice(float [] t) {
	 int n=t.length;
         a=new float[n][n];
	 col=n;
	 row=n;
         for(int i=0;i<n;i++) 
             for(int j=0;j<n;j++) 
                     a[i][j]= i==j? t[i] : 0;
     }
     matrice(int m,int n) {
         a=new float[m][n];
	 row=m;
	 col=n;
         for(int i=0;i<m;i++) 
             for(int j=0;j<n;j++) 
                     a[i][j]= 0;
     }
     float elt(int i,int j) {
         return a[i-1][j-1];
     }
     void affecte(int i,int j,float x) {
         a[i-1][j-1]=x;
     }
     matrice add(matrice b) throws MatriceException {
	 matrice c;
	 if(row==b.row && col==b.col) {
	     c=new matrice(row,col);
	     for(int i=0;i<row;i++)
		 for(int j=0;j<col;j++)
		     c.a[i][j]=a[i][j]+b.a[i][j]; 
	     return c;
	 } else throw new MatriceException("addition non dfinie");
     }
     static matrice add(matrice b1,matrice b2) throws MatriceException{
         return b1.add(b2);
     }
     matrice sub(matrice b) throws MatriceException {
	 matrice c;
         if(row==b.row && col==b.col) {
	     c=new matrice(row,col);
	     for(int i=0;i<row;i++)
		 for(int j=0;j<col;j++)
		     c.a[i][j]=a[i][j]-b.a[i][j];
	     return c;
	 } else throw new MatriceException("soustraction non dfinie");
     }
    static matrice sub(matrice b1,matrice b2) throws MatriceException{
         return b1.sub(b2);
     }
    matrice mult(matrice b) throws MatriceException {
	 matrice c;
         if(col==b.row) {
	     c=new matrice(row,b.col);
	     for(int i=0;i<row;i++)
		 for(int j=0;j<b.col;j++)
		     for(int k=0;k<col;k++)
		      	c.a[i][j]+=a[i][k]*b.a[k][j];
	     return c;
	 } else throw new MatriceException("soustraction non dfinie");
     }
    static matrice mult(matrice b1,matrice b2) throws MatriceException{
         return b1.mult(b2);
     }
    void ludcmp(float[] a, int[] indx, float d)
       {
	int i,imax,j,k;
	int n=row
	float big,dum,sum,temp;
	float[] vv=new float [n];

	d=1.0;
	for (i=0;i<n;i++) {
		big=0.0;
		for (j=0;j<n;j++)
			if ((temp=math.abs(a[i][j])) > big) big=temp;
		if (big == 0.0) throw new MatriceException("Singular matrix in routine ludcmp");
		vv[i]=1.0/big;
	}
	for (j=0;j<n;j++) {
		for (i=0;i<j;i++) {
			sum=a[i][j];
			for (k=0;k<i;k++) sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
		}
		big=0.0;
		for (i=j;i<n;i++) {
			sum=a[i][j];
			for (k=0;k<j;k++)
				sum -= a[i][k]*a[k][j];
			a[i][j]=sum;
			if ( (dum=vv[i]*math.abs(sum)) >= big) {
				big=dum;
				imax=i;
			}
		}
		if (j != imax) {
			for (k=0;k<n;k++) {
				dum=a[imax][k];
				a[imax][k]=a[j][k];
				a[j][k]=dum;
			}
			d = -(d);
			vv[imax]=vv[j];
		}
		indx[j]=imax;
		if (a[j][j] == 0.0) a[j][j]=TINY;
		if (j != n-1) {
			dum=1.0/(a[j][j]);
			for (i=j+1;i<n;i++) a[i][j] *= dum;
		}
	}
     }
     void gaussj(float[][] a, float [][] b){
        int n = a.length, m = b[1].length;
	int [] indxc, indxr, ipiv;
	int n,m,i,icol,irow,j,k,l,ll;
	float big,dum,pivinv,temp;

	indxc = new int[n+1];
	indxr = new int[n+1];
	ipiv = new int[n+1];
	for (j=1;j<=n;j++) ipiv[j]=0;
	for (i=1;i<=n;i++) {
		big=0.0;
		for (j=1;j<=n;j++)
			if (ipiv[j] != 1)
				for (k=1;k<=n;k++) {
					if (ipiv[k] == 0) {
						if (fabs(a[j][k]) >= big) {
							big=fabs(a[j][k]);
							irow=j;
							icol=k;
						}
					} else if (ipiv[k] > 1) nrerror("gaussj: Singular Matrix-1");
				}
		++(ipiv[icol]);
		if (irow != icol) {
			for (l=1;l<=n;l++) SWAP(a[irow][l],a[icol][l])
			for (l=1;l<=m;l++) SWAP(b[irow][l],b[icol][l])
		}
		indxr[i]=irow;
		indxc[i]=icol;
		if (a[icol][icol] == 0.0) nrerror("gaussj: Singular Matrix-2");
		pivinv=1.0/a[icol][icol];
		a[icol][icol]=1.0;
		for (l=1;l<=n;l++) a[icol][l] *= pivinv;
		for (l=1;l<=m;l++) b[icol][l] *= pivinv;
		for (ll=1;ll<=n;ll++)
			if (ll != icol) {
				dum=a[ll][icol];
				a[ll][icol]=0.0;
				for (l=1;l<=n;l++) a[ll][l] -= a[icol][l]*dum;
				for (l=1;l<=m;l++) b[ll][l] -= b[icol][l]*dum;
			}
	}
	for (l=n;l>=1;l--) {
		if (indxr[l] != indxc[l])
			for (k=1;k<=n;k++)
				SWAP(a[k][indxr[l]],a[k][indxc[l]]);
	}
}
     matrice inverse() throws MatriceException {
         if(row==col) {
             return this;
         }
         else throw new MatriceException("matrice non inversible");
     }
     matrice puissance(int n) throws MatriceException {
	 if(row==col) {
	     if(n==0) return new matrice(1,row);
	     else if(n<0) return power(inverse(),-n);
	     else {
	     }
	     
}

     
     