import java.io.*;
import java.lang.Math;


class Heapsort {
    static void downheap(double[] a,int k,int N) {
        int j;
        double v;
        v=a[k];
	while(k<=N/2) {
	    j=k+k;
	    if(j<N && a[j]<a[j+1]) j++;
	    if(v>=a[j]) break;
	    a[k]=a[j];
	    k=j;
	}
	a[k]=v;
    }
    
    static void heapsort(double[] a) {
        int k,N=a.length-1;
        for(k=N/2; k>=1; k--) {
            downheap(a,k,N);
        }
        while(N>1) {
            double temp=a[1];
            a[1]=a[N];
            a[N]=temp;
            downheap(a,1,--N);
        }
    }
    
    public static void main(String[] args) {
        int N=Integer.parseInt(args[0],10);
        double[] a=new double[N];
	for(int i=1;i<N;i++) {
            a[i]=Math.random();
        }
        heapsort(a);
        for(int i=0;i<N;i++) {
            System.out.println(a[i]);
        }
    }
}

    