import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class RCFrame extends Frame 
{	RCCanvas tableau;
    public static final int TRACE_POINT=0,CHERCHE_POINT=1,CHERCHE_DROITE=2,
               CHERCHE_CERCLE=3, CHERCHE_OBJET = 4;
    static int mode=TRACE_POINT;
    boolean canCreate=true;
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    GPoint pointCourant = new GPoint(0,0),dragPoint=null;
    double xClick,yClick;
    GeomObject oldObject;
    Color oldCouleur;
    Createur createur;
    courbeDialog leDialogue;
    AlertFrame alerteApplet;
    
	java.awt.MenuBar menuBarre = new java.awt.MenuBar();
	java.awt.Menu menuFichier = new java.awt.Menu();
	java.awt.MenuItem menuFichierChargerunefigure = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierEnregistrerlafigure = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierChargerdesconstructions = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierEnregistrerdesconstructions = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierSeparator3 = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierQuitter = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierSeparator2 = new java.awt.MenuItem();
	java.awt.MenuItem menuFichierparDenisMonasse = new java.awt.MenuItem();
	java.awt.MenuItem menuFichiermai2001 = new java.awt.MenuItem();
	java.awt.Menu menuPlacer = new java.awt.Menu();
	java.awt.MenuItem menuPlacerunpointlibre = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerunpointlieaunedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerunpointlieauncercle = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerunpointlieaunecourbe = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerLeRepere = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerToutretracer = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerMasquerdemasquer = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerToutdetruire = new java.awt.MenuItem();
	java.awt.MenuItem menuPlacerDetruireunobjet = new java.awt.MenuItem();
	java.awt.Menu menuPoints = new java.awt.Menu();
	java.awt.MenuItem menuPointsIntersectionde2droites = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsCentreduncercle = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsProjectionsurunedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsSymetriePoint = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsSymetriedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsIntersectionde2cercles = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsIntersectioncercledroite = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsMilieu = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsCentredecourbure = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsNommer = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsCouleur = new java.awt.MenuItem();
	java.awt.MenuItem menuPointsDetruire = new java.awt.MenuItem();
	java.awt.Menu menuDroites = new java.awt.Menu();
	java.awt.MenuItem menuDroitespar2points = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesParallele = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesPerpendiculaire = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesSymetriePoint = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesSymetriedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesMediatrice = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesAxeradical = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesBissectrices = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesTangente = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesNormale = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesCouleur = new java.awt.MenuItem();
	java.awt.MenuItem menuDroitesDetruire = new java.awt.MenuItem();
	java.awt.Menu menuCercles = new java.awt.Menu();
	java.awt.MenuItem menuCerclesparcentreetpoint = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclespardiametre = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclessymetriePoint = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclesSymetriedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclesOsculateur = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclesSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclesCouleur = new java.awt.MenuItem();
	java.awt.MenuItem menuCerclesDetruire = new java.awt.MenuItem();
	java.awt.Menu menuEnsembles = new java.awt.Menu();
	java.awt.MenuItem menuEnsemblesLieudunpoint = new java.awt.MenuItem();
	java.awt.MenuItem menuEnsemblesEnveloppedunedroite = new java.awt.MenuItem();
	java.awt.MenuItem menuEnsemblesSeparator1 = new java.awt.MenuItem();
	java.awt.MenuItem menuEnsemblesUtiliseruneconstruction = new java.awt.MenuItem();
	java.awt.MenuItem menuEnsemblesDefiniruneconstruction = new java.awt.MenuItem();
	java.awt.MenuItem menuEnsemblesDetruireuneconstruction = new java.awt.MenuItem();
	java.awt.Label commentLabel = new java.awt.Label();
	java.awt.Choice choixCouleur = new java.awt.Choice();

	public RCFrame()
	{   super();
	    try {
			initComponents();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	    show();
	}

	public void initComponents() throws Exception
	{
		menuBarre.add(menuFichier);
		menuBarre.add(menuPlacer);
		menuBarre.add(menuPoints);
		menuBarre.add(menuDroites);
		menuBarre.add(menuCercles);
		menuBarre.add(menuEnsembles);

		menuFichier.setLabel("Fichier");
		menuFichier.add(menuFichierChargerunefigure);
		menuFichier.add(menuFichierEnregistrerlafigure);
		menuFichier.add(menuFichierSeparator1);
		menuFichier.add(menuFichierChargerdesconstructions);
		menuFichier.add(menuFichierEnregistrerdesconstructions);
		menuFichier.add(menuFichierSeparator3);
		menuFichier.add(menuFichierQuitter);
		menuFichier.add(menuFichierSeparator2);
		menuFichier.add(menuFichierparDenisMonasse);
		menuFichier.add(menuFichiermai2001);

		// menuFichierChargerunefigure.setEnabled(false);
		menuFichierChargerunefigure.setLabel("Charger une figure");

		// menuFichierEnregistrerlafigure.setEnabled(false);
		menuFichierEnregistrerlafigure.setLabel("Enregistrer la figure");

		menuFichierSeparator1.setEnabled(false);
		menuFichierSeparator1.setLabel("-");

		menuFichierChargerdesconstructions.setEnabled(false);
		menuFichierChargerdesconstructions.setLabel("Charger des constructions");

		menuFichierEnregistrerdesconstructions.setEnabled(false);
		menuFichierEnregistrerdesconstructions.setLabel("Enregistrer des constructions");

		menuFichierSeparator3.setEnabled(false);
		menuFichierSeparator3.setLabel("-");

		menuFichierQuitter.setLabel("Quitter");

		menuFichierSeparator2.setLabel("-");

		menuFichierparDenisMonasse.setEnabled(false);
		menuFichierparDenisMonasse.setLabel("par Denis Monasse");

		menuFichiermai2001.setEnabled(false);
		menuFichiermai2001.setLabel("mai 2001");

		menuPlacer.setLabel("Placer");
		menuPlacer.add(menuPlacerunpointlibre);
		menuPlacer.add(menuPlacerunpointlieaunedroite);
		menuPlacer.add(menuPlacerunpointlieauncercle);
		menuPlacer.add(menuPlacerunpointlieaunecourbe);
		menuPlacer.add(menuPlacerLeRepere);
		menuPlacer.add(menuPlacerSeparator1);
		menuPlacer.add(menuPlacerToutretracer);
		menuPlacer.add(menuPlacerMasquerdemasquer);
		menuPlacer.add(menuPlacerToutdetruire);
		menuPlacer.add(menuPlacerDetruireunobjet);

		menuPlacerunpointlibre.setLabel("Point libre");

		menuPlacerunpointlieaunedroite.setLabel("Point lie a une droite");

		menuPlacerunpointlieauncercle.setLabel("Point lie a un cercle");

		menuPlacerunpointlieaunecourbe.setLabel("Point lie a une courbe");
		
		menuPlacerLeRepere.setLabel("Le repere");

		menuPlacerSeparator1.setEnabled(false);
		menuPlacerSeparator1.setLabel("-");

		menuPlacerToutretracer.setLabel("Tout retracer");

		menuPlacerMasquerdemasquer.setLabel("Masquer/demasquer");

		menuPlacerToutdetruire.setLabel("Tout detruire");

		menuPlacerDetruireunobjet.setLabel("Detruire un objet");

		menuPoints.setLabel("Points");
		menuPoints.add(menuPointsIntersectionde2droites);
		menuPoints.add(menuPointsCentreduncercle);
		menuPoints.add(menuPointsProjectionsurunedroite);
		menuPoints.add(menuPointsSymetriePoint);
		menuPoints.add(menuPointsSymetriedroite);
		menuPoints.add(menuPointsIntersectionde2cercles);
		menuPoints.add(menuPointsIntersectioncercledroite);
		menuPoints.add(menuPointsMilieu);
		menuPoints.add(menuPointsCentredecourbure);
		menuPoints.add(menuPointsSeparator1);
		menuPoints.add(menuPointsNommer);
		menuPoints.add(menuPointsCouleur);
		menuPoints.add(menuPointsDetruire);

		menuPointsIntersectionde2droites.setLabel("Intersection de 2 droites");

		menuPointsCentreduncercle.setLabel("Centre d'un cercle");

		menuPointsProjectionsurunedroite.setLabel("Projection sur une droite");

		menuPointsSymetriePoint.setLabel("Symetrie point");

		menuPointsSymetriedroite.setLabel("Symetrie droite");

		menuPointsIntersectionde2cercles.setLabel("Intersection de 2 cercles");

		menuPointsIntersectioncercledroite.setLabel("Intersection cercle droite");

		menuPointsMilieu.setLabel("Milieu");

		menuPointsCentredecourbure.setLabel("Centre de courbure");

		menuPointsSeparator1.setEnabled(false);
		menuPointsSeparator1.setLabel("-");

		menuPointsNommer.setLabel("Nommer");
		menuPointsCouleur.setLabel("Changer de couleur");
		menuPointsDetruire.setLabel("Detruire");

		menuDroites.setLabel("Droites");
		menuDroites.add(menuDroitespar2points);
		menuDroites.add(menuDroitesParallele);
		menuDroites.add(menuDroitesPerpendiculaire);
		menuDroites.add(menuDroitesSymetriePoint);
		menuDroites.add(menuDroitesSymetriedroite);
		menuDroites.add(menuDroitesMediatrice);
		menuDroites.add(menuDroitesAxeradical);
		menuDroites.add(menuDroitesBissectrices);
		menuDroites.add(menuDroitesTangente);
		menuDroites.add(menuDroitesNormale);
		menuDroites.add(menuDroitesSeparator1);
		menuDroites.add(menuDroitesCouleur);
		menuDroites.add(menuDroitesDetruire);

		menuDroitespar2points.setLabel("par 2 points");

		menuDroitesParallele.setLabel("Parallele");

		menuDroitesPerpendiculaire.setLabel("Perpendiculaire");

		menuDroitesSymetriePoint.setLabel("Symetrie point");

		menuDroitesSymetriedroite.setLabel("Symetrie droite");

		menuDroitesMediatrice.setLabel("Mediatrice");

		menuDroitesAxeradical.setLabel("Axe radical");

		menuDroitesBissectrices.setLabel("Bissectrices");

		menuDroitesTangente.setLabel("Tangente");

		menuDroitesNormale.setLabel("Normale");
		menuDroitesSeparator1.setEnabled(false);
		menuDroitesSeparator1.setLabel("-");
		menuDroitesCouleur.setLabel("Changer de couleur");
		menuDroitesDetruire.setLabel("Detruire");

		menuCercles.setLabel("Cercles");
		menuCercles.add(menuCerclesparcentreetpoint);
		menuCercles.add(menuCerclespardiametre);
		menuCercles.add(menuCerclessymetriePoint);
		menuCercles.add(menuCerclesSymetriedroite);
		menuCercles.add(menuCerclesOsculateur);
		menuCercles.add(menuCerclesSeparator1);
		menuCercles.add(menuCerclesCouleur);
		menuCercles.add(menuCerclesDetruire);

		menuCerclesparcentreetpoint.setLabel("par centre et point");

		menuCerclespardiametre.setLabel("par diametre");

		menuCerclessymetriePoint.setLabel("Symetrie point");

		menuCerclesSymetriedroite.setLabel("Symetrie droite");

		menuCerclesOsculateur.setLabel("Osculateur");
		menuCerclesSeparator1.setEnabled(false);
		menuCerclesSeparator1.setLabel("-");
		menuCerclesCouleur.setLabel("Changer de couleur");
		menuCerclesDetruire.setLabel("Detruire");

		menuEnsembles.setLabel("Ensembles");
		menuEnsembles.add(menuEnsemblesLieudunpoint);
		menuEnsembles.add(menuEnsemblesEnveloppedunedroite);
		menuEnsembles.add(menuEnsemblesSeparator1);
		menuEnsembles.add(menuEnsemblesUtiliseruneconstruction);
		menuEnsembles.add(menuEnsemblesDefiniruneconstruction);
		menuEnsembles.add(menuEnsemblesDetruireuneconstruction);

		menuEnsemblesLieudunpoint.setLabel("Lieu d'un point");
		menuEnsemblesEnveloppedunedroite.setLabel("Enveloppe d'une droite");

		menuEnsemblesSeparator1.setEnabled(false);
		menuEnsemblesSeparator1.setLabel("-");

		menuEnsemblesUtiliseruneconstruction.setEnabled(false);
		menuEnsemblesUtiliseruneconstruction.setLabel("Utiliser une construction");

		menuEnsemblesDefiniruneconstruction.setEnabled(false);
		menuEnsemblesDefiniruneconstruction.setLabel("Definir une construction");

		menuEnsemblesDetruireuneconstruction.setEnabled(false);
		menuEnsemblesDetruireuneconstruction.setLabel("Detruire une construction");

		commentLabel.setText("Tracez ou deplacez un point");
		commentLabel.setSize(250,15);
		commentLabel.setForeground(new java.awt.Color(255, 0, 0));
		commentLabel.setAlignment(Label.CENTER);
		commentLabel.setVisible(true);

		choixCouleur.setVisible(true);

		setLocation(new java.awt.Point(0, 0));
		setTitle("Regle et Compas");
		setLayout(new java.awt.FlowLayout(1, 5, 5));
		setMenuBar(menuBarre);
		setSize(new java.awt.Dimension(640, 480));
		add(commentLabel);
		add(choixCouleur);

		menuFichierChargerunefigure.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuChargerFigureAction(e);
			}
		});
		menuFichierEnregistrerlafigure.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEnregistrerFigureAction(e);
			}
		});
		menuPlacerunpointlibre.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerunpointlibreAction(e);
			}
		});
		menuPlacerunpointlieaunedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerunpointlieaunedroiteAction(e);
			}
		});
		menuPlacerunpointlieauncercle.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerunpointlieauncercleAction(e);
			}
		});
		menuPlacerunpointlieaunecourbe.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerCourbeAction(e);
			}
		});
		menuPlacerLeRepere.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerLeRepereAction(e);
			}
		});
		menuPlacerToutretracer.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerToutRetracerAction(e);
			}
		});
		menuPlacerMasquerdemasquer.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerMasquerDemasquerAction(e);
			}
		});
		menuPlacerToutdetruire.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerToutDetruireAction(e);
			}
		});
		menuPlacerDetruireunobjet.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPlacerDetruireObjetAction(e);
			}
		});
		menuPointsIntersectionde2droites.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsIntersectionde2droitesAction(e);
			}
		});
		menuPointsCentreduncercle.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsCentreduncercleAction(e);
			}
		});
		menuPointsProjectionsurunedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsProjectionsurunedroiteAction(e);
			}
		});
		menuPointsSymetriePoint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsSymetriePointAction(e);
			}
		});
		menuPointsSymetriedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsSymetrieDroiteAction(e);
			}
		});
		menuPointsIntersectionde2cercles.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsIntersectionde2cerclesAction(e);
			}
		});
		menuPointsIntersectioncercledroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsIntersectioncercledroiteAction(e);
			}
		});
		menuPointsMilieu.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsMilieuAction(e);
			}
		});
		menuPointsCentredecourbure.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsCentreCourbureAction(e);
			}
		});
		menuPointsCouleur.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsCouleurAction(e);
			}
		});
		menuPointsDetruire.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuPointsDetruireAction(e);
			}
		});
		menuDroitespar2points.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitespar2pointsAction(e);
			}
		});
		menuDroitesParallele.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesParalleleAction(e);
			}
		});
		menuDroitesPerpendiculaire.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesPerpendiculaireAction(e);
			}
		});
		menuDroitesSymetriePoint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesSymetriePointAction(e);
			}
		});
		menuDroitesSymetriedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesSymetriedroiteAction(e);
			}
		});
		menuDroitesMediatrice.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesMediatriceAction(e);
			}
		});
		menuDroitesBissectrices.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesBissectricesAction(e);
			}
		});
		menuDroitesTangente.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesTangenteAction(e);
			}
		});
		menuDroitesNormale.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesNormaleAction(e);
			}
		});
		menuDroitesCouleur.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesCouleurAction(e);
			}
		});
		menuDroitesDetruire.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuDroitesDetruireAction(e);
			}
		});
		menuCerclesparcentreetpoint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclesparcentreetpointAction(e);
			}
		});
		menuCerclespardiametre.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclespardiametreAction(e);
			}
		});
		menuCerclessymetriePoint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclessymetriePointAction(e);
			}
		});
		menuCerclesSymetriedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclesSymetriedroiteAction(e);
			}
		});
		menuCerclesOsculateur.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclesOsculateurAction(e);
			}
		});
		menuCerclesCouleur.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclesCouleurAction(e);
			}
		});
		menuCerclesDetruire.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuCerclesDetruireAction(e);
			}
		});
		menuEnsemblesLieudunpoint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEnsemblesLieuAction(e);
			}
		});
		menuEnsemblesEnveloppedunedroite.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				menuEnsemblesEnveloppeAction(e);
			}
		});
		choixCouleur.addItemListener(new java.awt.event.ItemListener() {
			public void itemStateChanged(java.awt.event.ItemEvent e) {
				choixCouleurItemStateChanged(e);
			}
		});
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

		choixCouleur.add("noir");
		choixCouleur.add("rouge");
		choixCouleur.add("bleu");
		choixCouleur.add("vert");
		choixCouleur.add("cyan");
		choixCouleur.add("jaune");
		choixCouleur.add("magenta");
		choixCouleur.add("orange");
		choixCouleur.add("invisible");
		
        setSize(new java.awt.Dimension(450, 450));
        tableau = new RCCanvas(1);
        tableau.setSize(new java.awt.Dimension(400, 400));
        tableau.addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(java.awt.event.MouseEvent e) {
				tableauMouseClicked(e);
			}
			public void mousePressed(java.awt.event.MouseEvent e) {
				tableauMousePressed(e);
			}
			public void mouseReleased(java.awt.event.MouseEvent e) {
				tableauMouseReleased(e);
			}
		});
		tableau.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
			public void mouseMoved(java.awt.event.MouseEvent e) {
				tableauMouseMoved(e);
			}
			public void mouseDragged(java.awt.event.MouseEvent e) {
				tableauMouseDragged(e);
			}
		});
		add(tableau);
		
		leDialogue = new courbeDialog(this);
		alerteApplet = new AlertFrame();
	}
  
  	private boolean mShown = false;
  	
	public void addNotify() 
	{
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}

		mShown = true;
	}
	
	public void valideMenusFichiers(){
	    menuFichierChargerunefigure.setEnabled(true);
		menuFichierEnregistrerlafigure.setEnabled(true);
	}
	   

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e)
	{
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	// Attente des objets et cration de nouveaux objets
	
	private class Createur extends Thread{
	       boolean finRecherche;
	       GeomObject cherche=null;
	        
	        synchronized void transmet(GeomObject obj){
	              cherche=obj;
	              finRecherche=true;
	              notifyAll();
	        }
	        
			synchronized GPoint attendPoint(String s){
		          mode = CHERCHE_POINT;
		          finRecherche=false;
		          commentLabel.setText(s);
		          while(!finRecherche){
		               try{wait(); }
		               catch(InterruptedException e)
		                   { return null ;}
		          };
		          mode = TRACE_POINT;
		          commentLabel.setText("Tracez ou deplacez un point");
		          return (GPoint) cherche;
		   }
		    
		   synchronized GDroite attendDroite(String s){
		          mode = CHERCHE_DROITE;
		          finRecherche=false;
		          commentLabel.setText(s);
		          while(!finRecherche){
		               try{ wait();}
		               catch(InterruptedException e)
		                   { return null ;}
		          };
		          mode = TRACE_POINT;
		          commentLabel.setText("Tracez ou deplacez un point");
		          return (GDroite) cherche;
		   }
		   
		   synchronized GCercle attendCercle(String s){
		          mode = CHERCHE_CERCLE;
		          finRecherche=false;
		          commentLabel.setText(s);
		          while(!finRecherche){
		               try{wait();}
		               catch(InterruptedException e)
		                   { return null ;}
		          };
		          mode = TRACE_POINT;
		          commentLabel.setText("Tracez ou deplacez un point");
		          return (GCercle) cherche;
		   }
		   
		   synchronized GeomObject attendObjet(String s){
		          mode = CHERCHE_OBJET;
		          finRecherche=false;
		          commentLabel.setText(s);
		          while(!finRecherche){
		               try{wait();}
		               catch(InterruptedException e)
		                   { return null ;}
		          };
		          mode = TRACE_POINT;
		          commentLabel.setText("Tracez ou deplacez un point");
		          return cherche;
		   }
   
   }
   
   GeomObject objetCherche;
   
   private class Attente extends Createur{
           int type;
           String message;
           
           Attente(int type,String message){
                this.type=type;
                this.message= message;
                start();
           }
           public void run(){
                GeomObject obj=null;
                switch(type){
                   case Geom.OBJET: obj=attendObjet(message); break;
                   case Geom.POINT: obj=attendPoint(message); break;
                   case Geom.DROITE: obj=attendDroite(message); break;
                   case Geom.CERCLE: obj=attendCercle(message); break;
                 }
                 objetCherche=obj;
            }
  }
  
  public GeomObject fournitObjet(){
          Attente at = new Attente(Geom.OBJET,"Choisissez un objet");
          return objetCherche;
  }
  
  public GPoint fournitPoint(){
          Attente at = new Attente(Geom.POINT,"Choisissez un point");
          return (GPoint)objetCherche;
  }
  
  public GDroite fournitDroite(){
          Attente at = new Attente(Geom.DROITE,"Choisissez une droite");
          return (GDroite)objetCherche;
  }
  
  public GCercle fournitCercle(){
          Attente at = new Attente(Geom.CERCLE,"Choisissez un cercle");
          return (GCercle)objetCherche;
  }
                   
   
   private class CreateurPointLieDroite extends Createur{
   			CreateurPointLieDroite(){
   			     start();
   			}
   			public void run(){
   			    GDroite d;
   			    d = attendDroite("Choisissez la droite support");
   			    if(d==null){ canCreate=true; return; }
   			    tableau.insere(GPoint.newPointLieDroite(xClick,yClick,d));
   			    canCreate=true;
   			}
   }
   
   private class CreateurPointLieCercle extends Createur{
   			CreateurPointLieCercle(){
   			     start();
   			}
   			public void run(){
   			    GCercle c;
   			    c = attendCercle("Choisissez le cercle support");
   			    if(c==null){ canCreate=true; return; }
   			    tableau.insere(GPoint.newPointLieCercle(xClick,yClick,c));
   			    canCreate=true;
   			}
   }
   
   private class CreateurDroitePar2Points extends Createur{
   			CreateurDroitePar2Points(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le premier point");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le deuxieme point");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newDroitePar2Points(m1,m2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurMilieu extends Createur{
   			CreateurMilieu(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le premier point");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le deuxieme point");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newMilieu(m1,m2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurPointSymetriePoint extends Createur{
   			CreateurPointSymetriePoint(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le point a symetriser");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le centre de symetrie");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newSymetrique(m1,m2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurPointSymetrieDroite extends Createur{
   			CreateurPointSymetrieDroite(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GDroite d;
   			    m = attendPoint("Choisissez le point a symetriser");
   			    if(m==null){ canCreate=true; return; }
   			    d = attendDroite("Choisissez la droite de symetrie");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newSymetrique(m,d));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurIntersection2Droites extends Createur{
   			CreateurIntersection2Droites(){
   			     start();
   			}
   			public void run(){
   			    GDroite d1,d2;
   			    d1 = attendDroite("Choisissez la premiere droite");
   			    if(d1==null){ canCreate=true; return; }
   			    d2 = attendDroite("Choisissez la deuxieme droite");
   			    if(d2==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newIntersection(d1,d2));
   			    canCreate=true;
   			}
   }
   private class CreateurCentreCercle extends Createur{
   			CreateurCentreCercle(){
   			     start();
   			}
   			public void run(){
   			    GCercle c;
   			    c = attendCercle("Choisissez le cercle");
   			    if(c==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newCentreCercle(c));
   			    canCreate=true;
   			}
   }
   private class CreateurIntersectionDroiteCercle extends Createur{
   			CreateurIntersectionDroiteCercle(){
   			     start();
   			}
   			public void run(){
   			    GDroite d; GCercle c;
   			    d = attendDroite("Choisissez la droite");
   			    if(d==null){ canCreate=true; return; }
   			    c = attendCercle("Choisissez le cercle");
   			    if(c==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newIntersection1(d,c));
   			    tableau.insere(GPoint.newIntersection2(d,c));
   			    canCreate=true;
   			}
   }
   
   private class CreateurIntersection2Cercles extends Createur{
   			CreateurIntersection2Cercles(){
   			     start();
   			}
   			public void run(){
   			    GCercle c1,c2;
   			    c1 = attendCercle("Choisissez le premier cercle");
   			    if(c1==null){ canCreate=true; return; }
   			    c2 = attendCercle("Choisissez le deuxieme cercle");
   			    if(c2==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newIntersection1(c1,c2));
   			    tableau.insere(GPoint.newIntersection2(c1,c2));
   			    canCreate=true;
   			}
   }
   
    private class CreateurProjectionDroite extends Createur{
   			CreateurProjectionDroite(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GDroite d;
   			    m = attendPoint("Choisissez le point a projeter");
   			    if(m==null){ canCreate=true; return; }
   			    d = attendDroite("Choisissez la droite de projection");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GPoint.newProjection(m,d));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurCentreCourbure extends Createur{
   			CreateurCentreCourbure(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; 
   			    m = attendPoint("Choisissez la courbe par son point courant");
   			    if(m==null || m.type!=Geom.COURBE){ canCreate=true; return; }
   			    tableau.insere(GPoint.newCentreDeCourbure((GCourbe) m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurParallele extends Createur{
   			CreateurParallele(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GDroite d;
   			    m = attendPoint("Choisissez le point de passage");
   			    if(m==null){ canCreate=true; return; }
   			    d = attendDroite("Choisissez la droite parallele");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newParallele(m,d));
   			    canCreate=true;
   			}
   }
   
   private class CreateurPerpendiculaire extends Createur{
   			CreateurPerpendiculaire(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GDroite d;
   			    m = attendPoint("Choisissez le point de passage");
   			    if(m==null){ canCreate=true; return; }
   			    d = attendDroite("Choisissez la droite perpendiculaire");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newPerpendiculaire(m,d));
   			    canCreate=true;
   			}
   }
   
   private class CreateurMediatrice extends Createur{
   			CreateurMediatrice(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le premier point");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le deuxieme point");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newMediatrice(m1,m2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurDroiteSymetriePoint extends Createur{
   			CreateurDroiteSymetriePoint(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GDroite d;
   			    d = attendDroite("Choisissez la droite a symetriser");
   			    if(d==null){ canCreate=true; return ; }
   			    m = attendPoint("Choisissez le centre de symetrie");
   			    if(m==null){ canCreate=true; return; }
   			    tableau.insere(GDroite.newSymetrique(d,m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurDroiteSymetrieDroite extends Createur{
   			CreateurDroiteSymetrieDroite(){
   			     start();
   			}
   			public void run(){
   			    GDroite d1,d2;
   			    d1 = attendDroite("Choisissez la droite a symetriser");
   			    if(d1==null){ canCreate=true; return; }
   			    d2 = attendDroite("Choisissez l'axe de symetrie");
   			    if(d2==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newSymetrique(d1,d2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurAxeRadical extends Createur{
   			CreateurAxeRadical(){
   			     start();
   			}
   			public void run(){
   			    GCercle c1,c2;
   			    c1 = attendCercle("Choisissez le premier cercle");
   			    if(c1==null){ canCreate=true; return; }
   			    c2 = attendCercle("Choisissez le deuxieme cercle");
   			    if(c2==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newAxeRadical(c1,c2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurBissectrices extends Createur{
   			CreateurBissectrices(){
   			     start();
   			}
   			public void run(){
   			    GDroite d1,d2;
   			    d1 = attendDroite("Choisissez la premiere droite");
   			    if(d1==null){ canCreate=true; return; }
   			    d2 = attendDroite("Choisissez la deuxieme droite");
   			    if(d2==null){ canCreate=true; return ; }
   			    tableau.insere(GDroite.newBissectrice1(d1,d2));
   			    tableau.insere(GDroite.newBissectrice2(d1,d2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurTangente extends Createur{
   			CreateurTangente(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; 
   			    m = attendPoint("Choisissez la courbe par son point courant");
   			    if(m==null || m.type!=Geom.COURBE){ canCreate=true; return; }
   			    tableau.insere(GDroite.newTangente((GCourbe) m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurNormale extends Createur{
   			CreateurNormale(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; 
   			    m = attendPoint("Choisissez la courbe par son point courant");
   			    if(m==null || m.type!=Geom.COURBE){ canCreate=true; return; }
   			    tableau.insere(GDroite.newNormale((GCourbe) m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurCercleParCentreEtPoint extends Createur{
   			CreateurCercleParCentreEtPoint(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le centre du cercle");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le point de passage");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GCercle.newCercleParCentreEtPoint(m1,m2));
   			    canCreate=true;
   			}
   }
   
   
   
   private class CreateurCercleParDiametre extends Createur{
   			CreateurCercleParDiametre(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2;
   			    m1 = attendPoint("Choisissez le premier point");
   			    if(m1==null){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le deuxieme point");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GCercle.newCercleParDiametre(m1,m2));
   			    canCreate=true;
   			}
   }
   
   private class CreateurCercleSymetriePoint extends Createur{
   			CreateurCercleSymetriePoint(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; GCercle c;
   			    c = attendCercle("Choisissez le cercle a symetriser");
   			    if(c==null){ canCreate=true; return ; }
   			    m = attendPoint("Choisissez le centre de symetrie");
   			    if(m==null){ canCreate=true; return; }
   			    tableau.insere(GCercle.newSymetrique(c,m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurCercleSymetrieDroite extends Createur{
   			CreateurCercleSymetrieDroite(){
   			     start();
   			}
   			public void run(){
   			    GDroite d; GCercle c;
   			    c = attendCercle("Choisissez le cercle a symetriser");
   			    if(c==null){ canCreate=true; return; }
   			    d = attendDroite("Choisissez l'axe de symetrie");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GCercle.newSymetrique(c,d));
   			    canCreate=true;
   			}
   }
   
   private class CreateurCercleOsculateur extends Createur{
   			CreateurCercleOsculateur(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; 
   			    m = attendPoint("Choisissez la courbe par son point courant");
   			    if(m==null || m.type!=Geom.COURBE){ canCreate=true; return; }
   			    tableau.insere(GCercle.newCercleOsculateur((GCourbe) m));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurLieu extends Createur{
   			CreateurLieu(){
   			     start();
   			}
   			public void run(){
   			    GPoint m1,m2; 
   			    m1 = attendPoint("Choisissez le point mobile");
   			    if(m1==null || (m1.type!=Geom.COURBE 
   			                    && m1.constr!=Geom.LIE_DROITE 
   			                    && m1.constr!=Geom.LIE_CERCLE)){ canCreate=true; return; }
   			    m2 = attendPoint("Choisissez le point du lieu");
   			    if(m2==null){ canCreate=true; return ; }
   			    tableau.insere(GEnsemble.newLieu(m1,m2));
   			    canCreate=true;
   			}
   } 
   
   private class CreateurEnveloppe extends Createur{
   			CreateurEnveloppe(){
   			     start();
   			}
   			public void run(){
   			    GPoint m; 
   			    GDroite d;
   			    m = attendPoint("Choisissez le point mobile");
   			    if(m==null || (m.type!=Geom.COURBE 
   			                    && m.constr!=Geom.LIE_DROITE 
   			                    && m.constr!=Geom.LIE_CERCLE)){ canCreate=true; return; }
   			    d = attendDroite("Choisissez la droite enveloppe");
   			    if(d==null){ canCreate=true; return ; }
   			    tableau.insere(GEnsemble.newEnveloppe(m,d));
   			    canCreate=true;
   			}
   } 
   
    private class DestructeurObjet extends Createur{
   			DestructeurObjet(){
   			     start();
   			}
   			public void run(){
   			    GeomObject obj;
   			    obj = attendObjet("Choisissez l'objet a detruire");
   			    if(obj==null){ canCreate=true; return; }
   			    tableau.detruire(obj);
   			    canCreate=true;
   			}
   }
   
   private class DestructeurPoint extends Createur{
   			DestructeurPoint(){
   			     start();
   			}
   			public void run(){
   			    GeomObject obj;
   			    obj = attendPoint("Choisissez le point a detruire");
   			    if(obj==null){ canCreate=true; return; }
   			    tableau.detruire(obj);
   			    canCreate=true;
   			}
   }
   
   private class DestructeurDroite extends Createur{
   			DestructeurDroite(){
   			     start();
   			}
   			public void run(){
   			    GeomObject obj;
   			    obj = attendDroite("Choisissez la droite a detruire");
   			    if(obj==null){ canCreate=true; return; }
   			    tableau.detruire(obj);
   			    canCreate=true;
   			}
   }
   
   private class DestructeurCercle extends Createur{
   			DestructeurCercle(){
   			     start();
   			}
   			public void run(){
   			    GeomObject obj;
   			    obj = attendCercle("Choisissez le cercle a detruire");
   			    if(obj==null){ canCreate=true; return; }
   			    tableau.detruire(obj);
   			    canCreate=true;
   			}
   }
   
   private class ModifieurCouleur extends Createur{
          int type;
          
          ModifieurCouleur(int type){
               this.type = type;
               start();
          }
          public void run(){
              GeomObject obj=null;
              switch(type){
                 case Geom.POINT : obj = attendPoint("Choisissez le point a modifier"); break;
                 case Geom.DROITE : obj = attendDroite("Choisissez la droite a modifier"); break;
                 case Geom.CERCLE : obj = attendCercle("Choisissez le cercle a modifier"); break;
              }
              if(obj==null){ canCreate=true; return; }
              oldCouleur = tableau.laCouleur;
              tableau.modifierCouleur(obj);
              canCreate = true;
           }
   }
         
   
   // Recherche d'un objet proche du curseur
   
   public GPoint cherchePoint(double x,double y){
	        GeomObject m = tableau.dernier;
	        double tolerance = tableau.tolerance();
	        pointCourant.x=x;
	        pointCourant.y=y;
	        while(m!=null){
	            if((m.type==Geom.POINT || m.type==Geom.COURBE) && pointCourant.proche((GPoint) m,tolerance))
	                   return (GPoint) m;
	            m=m.precedent;
	        }
	        return null;
	}
	
	public GDroite chercheDroite(double x,double y){
	        GeomObject d = tableau.dernier;
	        double tolerance = 2*tableau.tolerance();
	        pointCourant.x=x;
	        pointCourant.y=y;
	        while(d!=null){
	            if(d.type==Geom.DROITE && pointCourant.proche((GDroite) d,tolerance))
	                  return (GDroite) d;
	            d=d.precedent;
	        }
	        return null;
	}
	
	public GCercle chercheCercle(double x,double y){
	        GeomObject c = tableau.dernier;
	        double tolerance = 3*tableau.tolerance();
	        pointCourant.x=x;
	        pointCourant.y=y;
	        while(c!=null){
	            if(c.type==Geom.CERCLE && pointCourant.proche((GCercle) c,tolerance))
	                  return (GCercle) c;
	            c=c.precedent;
	        }
	        return null;
	}
	
	public GeomObject chercheObjet(double x,double y){
	        GeomObject obj = tableau.dernier;
	        double tolerance = tableau.tolerance();
	        pointCourant.x=x;
	        pointCourant.y=y;
	        while(obj!=null){
	            switch(obj.type){
	               case Geom.POINT:
	               case Geom.COURBE:
	                   if(pointCourant.proche((GPoint) obj,tolerance))
	                      { return obj; }
	                    break;
	               case Geom.DROITE:
	                    if(pointCourant.proche((GDroite) obj,2*tolerance))
	                      { return obj; }
	                     break;
	               case Geom.CERCLE:
	                    if(pointCourant.proche((GCercle) obj,3*tolerance))
	                       { return obj; }
	                     break;
	            }
	            obj=obj.precedent;
	        }
	        return null;
	}
	
	// Traitement du composant Choice pour la couleur
	
   public void choixCouleurItemStateChanged(java.awt.event.ItemEvent e)
	{	if(e.getItemSelectable()== choixCouleur) {
              	String s=((Choice) e.getItemSelectable()).getSelectedItem();
              	if(s.equals("rouge")) {
              		tableau.setCouleur(Color.red);
              	}
				if(s.equals("bleu")) {
              		tableau.setCouleur(Color.blue);
              	}
				if(s.equals("vert")) {
              		tableau.setCouleur(Color.green);
              	}
				if(s.equals("cyan")) {
              		tableau.setCouleur(Color.cyan);
              	}
				if(s.equals("jaune")) {
              		tableau.setCouleur(Color.yellow);
              	}
				if(s.equals("magenta")) {
              		tableau.setCouleur(Color.magenta);
              	}
				if(s.equals("orange")) {
              		tableau.setCouleur(Color.orange);
              	}
				if(s.equals("noir")) {
              		tableau.setCouleur(Color.black);
              	}
              	if(s.equals("invisible")) {
              		tableau.setCouleur(Color.white);
              	}
              }
	}
	
	
   // Evenements souris
    

   	void tableauMouseClicked(MouseEvent e){
   		tableau.actualiseCoords();
   		xClick = tableau.xFloat(e.getX());
   		yClick = tableau.yFloat(e.getY());
   		e.consume();
   		clickReel(xClick,yClick);
    }
    
    synchronized void clickReel(double x,double y){
        switch(mode){
           case TRACE_POINT:
                GPoint m =  cherchePoint(x,y);
	            if(m==null){
	                 tableau.insere(new GPoint(x,y));
	                 tableau.repaint();
	            } else if(m.type==Geom.COURBE){
		            leDialogue.definitCourbe((GCourbe) m,false);
	                if(leDialogue.valide){
	                     ((GCourbe) m).doCourbe();
	                     tableau.recalculeTout();
	                     tableau.repaint();
	                }
	            }
		        break;
		   case CHERCHE_POINT:
		   		createur.transmet(cherchePoint(x,y));
		   		break;
		   case CHERCHE_DROITE:
		        createur.transmet(chercheDroite(x,y));
		   		break;
		   case CHERCHE_CERCLE:
		        createur.transmet(chercheCercle(x,y));
		   		break;
		   case CHERCHE_OBJET:
		        createur.transmet(chercheObjet(x,y));
		   		break;
		}
    }
    
    void tableauMousePressed(MouseEvent e){
   		tableau.actualiseCoords();
   		xClick = tableau.xFloat(e.getX());
   		yClick = tableau.yFloat(e.getY());
   		e.consume();
   		pressReel(xClick,yClick);
    }
    
    void pressReel(double x,double y){
        if(mode == TRACE_POINT){
            dragPoint = cherchePoint(x,y);
        }
    }
    
    void tableauMouseReleased(MouseEvent e){
   		dragPoint = null;
    }
    
    void tableauMouseMoved(MouseEvent e){
   		tableau.actualiseCoords();
   		moveReel(tableau.xFloat(e.getX()),tableau.yFloat(e.getY()));
    }
    
     void moveReel(double x,double y){  // synchronized  ?
        GPoint m;
        switch(mode){
           case TRACE_POINT:
                m = cherchePoint(x,y);
		   		if(m != null && m != oldObject && 
		   		  (m.constr==Geom.LIBRE || m.constr==Geom.LIE_DROITE 
		   		                        || m.constr==Geom.LIE_CERCLE 
		   		                        || m.constr==Geom.LIE_COURBE)) {
		   		    if(oldObject != null) oldObject.couleur = oldCouleur;
		   		    oldCouleur = m.couleur;
		   		    oldObject = m;
		   		    m.couleur = Color.red;
		   		    tableau.repaint();
		   		} else if(m==null && oldObject != null){
	                    oldObject.couleur = oldCouleur;
	                    tableau.repaint();
	                    oldObject=null;
                }
		   		break;
		   case CHERCHE_POINT:
		   		m = cherchePoint(x,y);
		   		if(m != null && m != oldObject) {
		   		    if(oldObject != null) oldObject.couleur = oldCouleur;
		   		    oldCouleur = m.couleur;
		   		    oldObject = m;
		   		    m.couleur = Color.red;
		   		    tableau.repaint();
		   		} else if(m==null && oldObject != null){
	                    oldObject.couleur = oldCouleur;
	                    tableau.repaint();
	                    oldObject=null;
                }
		   		break;
		   case CHERCHE_DROITE:
		        GDroite d = chercheDroite(x,y);
		   		if(d != null && d != oldObject) {
		   		    if(oldObject != null) oldObject.couleur = oldCouleur;
		   		    oldCouleur = d.couleur;
		   		    oldObject = d;
		   		    d.couleur = Color.red;
		   		    tableau.repaint();
		   		} else if(d==null && oldObject != null){
	                    oldObject.couleur = oldCouleur;
	                    tableau.repaint();
	                    oldObject=null;
                }
		   		break;
		   case CHERCHE_CERCLE:
		        GCercle c = chercheCercle(x,y);
		   		if(c != null && c != oldObject) {
		   		    if(oldObject != null) oldObject.couleur = oldCouleur;
		   		    oldCouleur = c.couleur;
		   		    oldObject = c;
		   		    c.couleur = Color.red;
		   		    tableau.repaint();
		   		} else if(c==null && oldObject != null){
	                    oldObject.couleur = oldCouleur;
	                    tableau.repaint();
	                    oldObject=null;
                }
		   		break;
		   case CHERCHE_OBJET:
		        GeomObject obj = chercheObjet(x,y);
		   		if(obj != null && obj != oldObject) {
		   		    if(oldObject != null) oldObject.couleur = oldCouleur;
		   		    oldCouleur = obj.couleur;
		   		    oldObject = obj;
		   		    obj.couleur = Color.red;
		   		    tableau.repaint();
		   		} else if(obj==null && oldObject != null){
	                    oldObject.couleur = oldCouleur;
	                    tableau.repaint();
	                    oldObject=null;
                }
		   		break;
		}
    }
    
    void tableauMouseDragged(MouseEvent e){
   		tableau.actualiseCoords();
   		dragReel(tableau.xFloat(e.getX()),tableau.yFloat(e.getY()));
    }
    
    void dragReel(double x,double y){
    	if(mode == TRACE_POINT && dragPoint != null){
    	    switch(dragPoint.constr){
    	       case Geom.LIBRE : 
    	       case Geom.LIE_DROITE :
    	       case Geom.LIE_CERCLE :		
    	            dragPoint.x = x;
    	       		dragPoint.y = y;
    	       		tableau.recalculeTout();
    	       		tableau.repaint();
    	       		break;    
    	    }
	     }
    }
    
    private void editeCourbe(GCourbe laCourbe){
                leDialogue.definitCourbe(laCourbe,false);
                if(leDialogue.valide){
                     laCourbe.doCourbe();
                     tableau.recalculeTout();
                     tableau.repaint();
                }
    }
    
    // Traitement des menus
    
    // Menu Fichier
    
    public void menuChargerFigureAction(java.awt.event.ActionEvent e){
       try{
         RCFileDialog fd = new RCFileDialog(this,"Charger une figure",false);
         String nom = fd.getFilename();
         if(nom != null){
            ObjectInputStream in = new ObjectInputStream(
               new FileInputStream(nom));
            GeomArray lesObjets = (GeomArray) in.readObject();
            in.close();
            lesObjets.installe(tableau);
         }
       }
       catch(StreamCorruptedException ee)
          { System.out.println("StreamCorruptedException");}
       catch(OptionalDataException ee)
          { System.out.println("OptionalDataException");}
       catch(FileNotFoundException ee)
          { System.out.println("FileNotFoundException");}
       catch(IOException ee)
          { System.out.println("IOException");}
       catch(ClassNotFoundException ee)
          { System.out.println("ClassNotFoundException");}
       catch(SecurityException ee)
          { alerteApplet.setVisible(true); }
    }
    
    public void menuEnregistrerFigureAction(java.awt.event.ActionEvent e){
       try{
         RCFileDialog fd = new RCFileDialog(this,"Enregistrer la figure",true);
         String nom = fd.getFilename();
         if(nom != null){
            ObjectOutputStream out = new ObjectOutputStream(
               new FileOutputStream(nom));
            out.writeObject(new GeomArray(tableau.premier));
            out.close();
         }
       } catch(IOException ee)
          { System.out.println("IOException");}
         catch(SecurityException ee)
          { alerteApplet.setVisible(true); }
    }
    
    
    //  Menu  Placer
    
	public void menuPlacerunpointlibreAction(java.awt.event.ActionEvent e)
	{    mode = TRACE_POINT;
	}
	
	public void menuPlacerunpointlieaunedroiteAction(java.awt.event.ActionEvent e)
	{	if(canCreate) {
	      canCreate=false;
	      createur = new CreateurPointLieDroite();
	    } else toolkit.beep();
	}
	
	public void menuPlacerunpointlieauncercleAction(java.awt.event.ActionEvent e)
	{	if(canCreate) {
	      canCreate=false;
	      createur = new CreateurPointLieCercle();
	    } else toolkit.beep();
	}
	
	public void menuPlacerCourbeAction(java.awt.event.ActionEvent e)
	{    if(canCreate) {
                GCourbe laCourbe=new GCourbe();
                leDialogue.definitCourbe(laCourbe,true);
                if(leDialogue.valide){
                     laCourbe.doCourbe();
                     tableau.insere(laCourbe);
                }
           }  else toolkit.beep();
	}
	
	public void menuPlacerLeRepereAction(java.awt.event.ActionEvent e)
	{    
	       if(canCreate) {
	            GPoint m0 = new GPoint(0,0), 
	                   m1 = new GPoint(1,0),
	                   m2 = new GPoint(0,1);
	            tableau.insere(m0);
                tableau.insere(m1);
                tableau.insere(m2);
                tableau.insere(GDroite.newDroitePar2Points(m0,m1));
                tableau.insere(GDroite.newDroitePar2Points(m0,m2));
                
           }  else toolkit.beep();
	}
	
	public void menuPlacerToutRetracerAction(java.awt.event.ActionEvent e)
	{   tableau.repaint();
	}
	
	public void menuPlacerMasquerDemasquerAction(java.awt.event.ActionEvent e)
	{   tableau.changeVisibles();
	}
	
	public void menuPlacerToutDetruireAction(java.awt.event.ActionEvent e)
	{	tableau.premier=null;
	    tableau.repaint();
	}
	
	public void menuPlacerDetruireObjetAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new DestructeurObjet();
	    } else toolkit.beep();
	}
	
	
	//  Menu Points
	
	public void menuPointsIntersectionde2droitesAction(java.awt.event.ActionEvent e)
	{ if(canCreate) {
	      canCreate=false;
	      createur = new CreateurIntersection2Droites();
	    } else toolkit.beep();
	}
	
	public void menuPointsCentreduncercleAction(java.awt.event.ActionEvent e)
	{	if(canCreate) {
	      canCreate=false;
	      createur = new CreateurCentreCercle();
	    } else toolkit.beep();
	}
	
	public void menuPointsProjectionsurunedroiteAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurProjectionDroite();
	    } else toolkit.beep();
	}
	
	public void menuPointsSymetriqueAction(java.awt.event.ActionEvent e)
	{
	}
	
	public void menuPointsIntersectionde2cerclesAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurIntersection2Cercles();
	    } else toolkit.beep();
	}
	
	public void menuPointsIntersectioncercledroiteAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurIntersectionDroiteCercle();
	    } else toolkit.beep();
	}
	
	public void menuPointsMilieuAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurMilieu();
	    } else toolkit.beep();
	}
	
	public void menuPointsSymetrieDroiteAction(java.awt.event.ActionEvent e)
	{ if(canCreate) {
	      canCreate=false;
	      createur = new CreateurPointSymetrieDroite();
	    } else toolkit.beep();
	}
	
	public void menuPointsSymetriePointAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurPointSymetriePoint();
	    } else toolkit.beep();
	}
	
	public void menuPointsCentreCourbureAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurCentreCourbure();
	    } else toolkit.beep();
	}
	
	public void menuPointsCouleurAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new ModifieurCouleur(Geom.POINT);
	    } else toolkit.beep();
	}
	
	public void menuPointsDetruireAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new DestructeurPoint();
	    } else toolkit.beep();
	}
	
	// Menu Droites
	
	public void menuDroitespar2pointsAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	        canCreate=false;
	        createur = new CreateurDroitePar2Points();
	   } else toolkit.beep();
	}
	
	public void menuDroitesParalleleAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	        canCreate=false;
	        createur = new CreateurParallele();
	   } else toolkit.beep();
	}
	
	public void menuDroitesPerpendiculaireAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	        canCreate=false;
	        createur = new CreateurPerpendiculaire();
	   } else toolkit.beep();
	}
	
	public void menuDroitesSymetriePointAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurDroiteSymetriePoint();
	    } else toolkit.beep();
	}
	
	public void menuDroitesSymetriedroiteAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurDroiteSymetrieDroite();
	    } else toolkit.beep();
	}
	
	public void menuDroitesMediatriceAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurMediatrice();
	    } else toolkit.beep();
	}
	
	public void menuDroitesAxeradicalAction(java.awt.event.ActionEvent e)
	{ if(canCreate) {
	      canCreate=false;
	      createur = new CreateurAxeRadical();
	    } else toolkit.beep();
	}
	
	public void menuDroitesBissectricesAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	        canCreate=false;
	        createur = new CreateurBissectrices();
	   } else toolkit.beep();
	}
	
	public void menuDroitesTangenteAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurTangente();
	    } else toolkit.beep();
	}
	
	public void menuDroitesNormaleAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurNormale();
	    } else toolkit.beep();
	}
	
	public void menuDroitesCouleurAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new ModifieurCouleur(Geom.DROITE);
	    } else toolkit.beep();
	}
	
	public void menuDroitesDetruireAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new DestructeurDroite();
	    } else toolkit.beep();
	}
	
	// Menu Cercles
	
	
	public void menuCerclesparcentreetpointAction(java.awt.event.ActionEvent e)
	{ if(canCreate) {
	        canCreate=false;
	        createur = new CreateurCercleParCentreEtPoint();
	   } else toolkit.beep();
	}
	
	public void menuCerclespardiametreAction(java.awt.event.ActionEvent e)
	{ if(canCreate) {
	        canCreate=false;
	        createur = new CreateurCercleParDiametre();
	   } else toolkit.beep();
	}
	
	
	public void menuCerclessymetriePointAction(java.awt.event.ActionEvent e)
	{  if(canCreate) {
	      canCreate=false;
	      createur = new CreateurCercleSymetriePoint();
	    } else toolkit.beep();
	}
	
	public void menuCerclesSymetriedroiteAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurCercleSymetrieDroite();
	    } else toolkit.beep();
	}
	
	public void menuCerclesOsculateurAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurCercleOsculateur();
	    } else toolkit.beep();
	}
	
	public void menuCerclesCouleurAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new ModifieurCouleur(Geom.CERCLE);
	    } else toolkit.beep();
	}
	
	public void menuCerclesDetruireAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new DestructeurCercle();
	    } else toolkit.beep();
	}
	
	// Menu Ensembles
	
	public void menuEnsemblesLieuAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurLieu();
	    } else toolkit.beep();
	}
	
	public void menuEnsemblesEnveloppeAction(java.awt.event.ActionEvent e)
	{   if(canCreate) {
	      canCreate=false;
	      createur = new CreateurEnveloppe();
	    } else toolkit.beep();
	}
		
}
